## vitis-ai 2.0

=== tools/Vitis-AI-Library/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#

cmake_minimum_required(VERSION 3.5)

if(DEFINED ENV{BUILD_VER})
  project(
    vitis_ai_library
    VERSION $ENV{BUILD_VER}
    LANGUAGES C CXX)
else()
  project(
    vitis_ai_library
    VERSION 2.0.0
    LANGUAGES C CXX)
endif()

include(${CMAKE_SOURCE_DIR}/cmake/XilinxCommon.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/vitis_ai_library_common.cmake)

# options
option(DISABLE_ALL "disable all libraries" OFF)
option(ENABLE_CLASSIFICATION "enable classification" OFF)
option(ENABLE_TFSSD "enable tfssd" OFF)
option(ENABLE_SSD "enable ssd" OFF)
option(ENABLE_FACEDETECT "enable face detection" OFF)
option(ENABLE_FACERECOG "enable face recog" OFF)
option(ENABLE_FACEDETECTRECOG "enable face detect recog" OFF)
option(ENABLE_FACEFEATURE "enable face feature" OFF)
option(ENABLE_FACEQUALITY5PT "enable face quality 5pt" OFF)
option(ENABLE_LANEDETECT "enable lane detection" OFF)
option(ENABLE_YOLOV2 "enable Yolov2" OFF)
option(ENABLE_YOLOV3 "enable Yolov3" OFF)
option(ENABLE_YOLOV5 "enable Yolov5" OFF)
option(ENABLE_YOLOVX "enable YolovX" OFF)
option(ENABLE_SOLO "enable Solo" OFF)
option(ENABLE_C2D2_LITE "enable c2d2_lite" OFF)
option(ENABLE_RGBDSEGMENTATION "enable RGBDsegmentation" OFF)
option(ENABLE_POLYPSEGMENTATION "enable polypsegmentation" OFF)
option(ENABLE_LANDMARK "enable landmark face-5pt" OFF)
option(ENABLE_SEGMENTATION "enable segmentation" OFF)
option(ENABLE_COVID19SEGMENTATION "enable covid19segmentation" OFF)
option(ENABLE_3DSEGMENTATION "enable 3dsegmentation" OFF)
option(ENABLE_REFINEDET "enable refinedet" OFF)
option(ENABLE_OPENPOSE "enable openpose" OFF)
option(ENABLE_HOURGLASS "enable hourglass" OFF)
option(ENABLE_POSEDETECT "enable pose detect" OFF)
option(ENABLE_REID "enable reid" OFF)
option(ENABLE_RCAN "enable rcan" OFF)
option(ENABLE_SOLO "enable solo" OFF)
option(ENABLE_FAIRMOT "enable fairmot" OFF)
option(ENABLE_REIDTRACKER "enable reidtracker" OFF)
option(ENABLE_MULTITASK "enable multitask" OFF)
option(ENABLE_MULTITASKV3 "enable multitaskv3" OFF)
option(ENABLE_PLATEDETECT "enable platedetect" OFF)
option(ENABLE_PLATENUM "enable platenum" OFF)
option(ENABLE_PLATERECOG "enable platerecog" OFF)
option(ENABLE_CARPLATERECOG "enable carplaterecog" OFF)
option(ENABLE_PSMNET "enable psmnet" OFF)
if(IS_DIRECTORY overview)
  option(ENABLE_OVERVIEW "enable overview" ON)
else(DIRECTORY overview)
  option(ENABLE_OVERVIEW "enable overview" OFF)
endif(IS_DIRECTORY overview)
message(STATUS "ENABLE_OVERVIEW=${ENABLE_OVERVIEW}")
option(ENABLE_GENERAL "enable general" OFF)
option(ENABLE_MEDICALSEGMENTATION "enable medicalsegmentation" OFF)
option(ENABLE_MEDICALDETECTION "enable medicaldetection" OFF)
option(ENABLE_POINTPILLARS "enable pointpillars" OFF)
option(ENABLE_POINTPILLARS_NUSCENES "enable pointpillars-nuscenes" OFF)
option(ENABLE_POINTPAINTING "enable pointpainting" OFF)
option(ENABLE_CENTERPOINTS "enable centerpoints" OFF)
option(ENABLE_RETINAFACE "enable retinaface" OFF)
option(ENABLE_MNISTCLASSIFICATION "enable mnistclassification" OFF)
option(ENABLE_MEDICALSEGCELL "enable medicalsegcell" OFF)
option(ENABLE_BCC "enable bcc" OFF)
option(ENABLE_PMG "enable pmg" OFF)
option(ENABLE_ULTRAFAST "enable ultrafast" OFF)
#option(ENABLE_OCR "enable ocr" OFF)
option(ENABLE_BTS "enable bts" OFF)
option(ENABLE_FUSION_CNN "enable fusion_cnn " OFF)
option(ENABLE_CLOCS "enable clocs " OFF)
option(ENABLE_X_AUTONOMOUS3D "enable x_autonomous3d" OFF)
option(ENABLE_DPUCADX8G_RUNNER "enable DPUV1 Runner" OFF)
option(ENABLE_DPUCADF8H_RUNNER "enable DPUV3INT8 Runner" OFF)

# variables
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_LIST_DIR}/cmake")
set(INSTALL_LIB_DIR lib)
set(INSTALL_BIN_DIR bin)
set(INSTALL_INCLUDE_DIR include)
set(INSTALL_CMAKE_DIR share/cmake/${PROJECT_NAME})

if(ENABLE_DPUCADX8G_RUNNER)
  # Enble supported models for DPUV1
  unset(DISABLE_ALL CACHE)
  unset(ENABLE_CLASSIFICATION CACHE)
  unset(ENABLE_FACEDETECT CACHE)
  unset(ENABLE_YOLOV3 CACHE)
  unset(ENABLE_LANDMARK CACHE)
  unset(ENABLE_FACEQUALITY5PT CACHE)
  unset(ENABLE_REID CACHE)
  unset(ENABLE_RETINAFACE CACHE)
  option(DISABLE_ALL "disable all libraries" ON)
  option(ENABLE_CLASSIFICATION "enable classification" ON)
  option(ENABLE_FACEDETECT "enable face detection" ON)
  option(ENABLE_FACEFEATURE "enable face feature" ON)
  option(ENABLE_YOLOV3 "enable Yolov3" ON)
  option(ENABLE_LANDMARK "enable landmark face-5pt" ON)
  option(ENABLE_FACEQUALITY5PT "enable face quality 5pt" ON)
  option(ENABLE_REID "enable reid" ON)
  option(ENABLE_RETINAFACE "enable face detection" ON)

  # Enable DPUV1 flag
  add_definitions(-DENABLE_DPUCADX8G_RUNNER)
endif()

if(ENABLE_DPUCADF8H_RUNNER)
  # Enble supported models for DPUCADF8H
  unset(DISABLE_ALL CACHE)
  unset(ENABLE_CLASSIFICATION CACHE)
  option(DISABLE_ALL "disable all libraries" ON)
  option(ENABLE_CLASSIFICATION "enable classification" ON)
endif()

# find packages
find_package(unilog)
find_package(xir)
find_package(
  vart
  COMPONENTS util
             xrt-device-handle
             buffer-object
             dpu-controller
             runner
             dpu-runner
             runner-assistant
             mem-manager
             trace
  REQUIRED)
find_package(Protobuf 3.4.0 REQUIRED)
find_package(Eigen3 REQUIRED)
find_package(Xrt MODULE)
find_package(OpenCV COMPONENTS opencv_core opencv_video opencv_videoio
                               opencv_imgproc opencv_imgcodecs opencv_highgui)
if(NOT OpenCV_FOUND)
  find_package(
    OpenCV_LIBS
    opencv_core
    opencv_video
    opencv_videoio
    opencv_imgproc
    opencv_imgcodecs
    opencv_highgui)
endif(NOT OpenCV_FOUND)
find_package(PkgConfig REQUIRED)
pkg_search_module(JSONC REQUIRED IMPORTED_TARGET json-c)

enable_testing()

# add subirectories
add_subdirectory(usefultools)
add_subdirectory(benchmark)

set(PACKAGE_COMPONENTS
    cxir
    cvart
    extra_ops
    model_config
    math
    runner_helper
    dpu_task
    cpu_task
    graph_runner
    xnnpp
    xmodel_jit
    xmodel_image)

if(ENABLE_CLASSIFICATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS classification)
endif()

if(ENABLE_TFSSD OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS tfssd)
endif()

if(ENABLE_FACEDETECT OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS facedetect)
endif()

if(ENABLE_FACEFEATURE OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS facefeature)
endif()

if(ENABLE_LANEDETECT OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS lanedetect)
endif()

if(ENABLE_YOLOV2 OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS yolov2)
endif()

if(ENABLE_YOLOV3 OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS yolov3)
endif()

if(ENABLE_YOLOV5 AND (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS yolov5)
endif()

if(ENABLE_YOLOVX OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS yolovx)
endif()

if(ENABLE_SOLO OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS solo)
endif()

if(ENABLE_C2D2_LITE OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS c2d2_lite)
endif()

if(ENABLE_RGBDSEGMENTATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS RGBDsegmentation)
endif()

if(ENABLE_POLYPSEGMENTATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS polypsegmentation)
endif()

if(ENABLE_LANDMARK OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS facelandmark)
endif()

if(ENABLE_FACEQUALITY5PT OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS facequality5pt)
endif()

if(ENABLE_SSD OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS ssd)
endif()

if(ENABLE_SEGMENTATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS segmentation)
endif()

if(ENABLE_COVID19SEGMENTATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS covid19segmentation)
endif()

if(ENABLE_3DSEGMENTATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS 3Dsegmentation)
endif()

if(ENABLE_REFINEDET OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS refinedet)
endif()

if(ENABLE_OPENPOSE OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS openpose)
endif()

if(ENABLE_HOURGLASS OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS hourglass)
endif()

if(ENABLE_POSEDETECT OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS posedetect)
endif()

if(ENABLE_REID OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS reid)
endif()

if(ENABLE_RCAN OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS rcan)
endif()


if(ENABLE_FAIRMOT OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS fairmot)
endif()

if(ENABLE_REIDTRACKER OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS reidtracker)
endif()

if(ENABLE_MULTITASK OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS multitask)
endif()

if(ENABLE_MULTITASKV3 OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS multitaskv3)
endif()

if(ENABLE_PLATEDETECT OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS platedetect)
endif()

if(ENABLE_PLATENUM OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS platenum)
endif()

if(ENABLE_PLATERECOG OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS platerecog)
endif()

if(ENABLE_CARPLATERECOG OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS carplaterecog)
endif()

if(ENABLE_MEDICALSEGMENTATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS medicalsegmentation)
endif()

if(ENABLE_MEDICALDETECTION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS medicaldetection)
endif()

if(ENABLE_FACERECOG OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS facerecog)
endif()

if(ENABLE_FACEDETECTRECOG OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS facedetectrecog)
endif()

if(ENABLE_POINTPILLARS OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS pointpillars)
endif()

if(ENABLE_POINTPILLARS_NUSCENES OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS pointpillars_nuscenes)
endif()

if(ENABLE_POINTPAINTING OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS pointpainting)
endif()

if(ENABLE_CENTERPOINT OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS centerpoint)
endif()

if(ENABLE_RETINAFACE OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS retinaface)
endif()

if(ENABLE_MNISTCLASSIFICATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS mnistclassification)
endif()

if(ENABLE_MEDICALSEGCELL OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS medicalsegcell)
endif()

if(ENABLE_BCC OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS bcc)
endif()

if(ENABLE_PMG OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS pmg)
endif()

if(ENABLE_ULTRAFAST OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS ultrafast)
endif()

#if(ENABLE_OCR OR (NOT DISABLE_ALL))
#  list(APPEND PACKAGE_COMPONENTS ocr)
#endif()

if(ENABLE_BTS AND (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS bts)
endif()

if(ENABLE_FUSION_CNN OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS fusion_cnn)
endif()

if(ENABLE_CLOCS OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS clocs)
endif()

if(ENABLE_X_AUTONOMOUS3D AND (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS x_autonomous3d)
endif()

# NOTE: general1 refer to many other libs, so it must be the last components in
# the list
if(ENABLE_GENERAL OR (NOT DISABLE_ALL))
  # use general1 instead of general because general is a special target name in
  # cmake
  list(APPEND PACKAGE_COMPONENTS general1)
endif()

foreach(COMPONENT ${PACKAGE_COMPONENTS})
  add_subdirectory(${COMPONENT})
endforeach()

=== tools/Vitis-AI-Library/Makefile ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

script_path := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))


all:
	bash -ex build_all.sh

## build latest dev branch(not include Vitis-AI-Library) 
dev:
	(cd ..; [ -d unilog ] && rm -rf unilog; [ -d xir ] && rm -rf xir; [ -d target_factory ] && rm -rf target_factory; [ -d vart ] && rm -rf vart; cd -; bash -ex build_all.sh)


clean_build:
	bash -ex build_all.sh --clean

unilog:
	(cd ..; [ -d unilog ] ||  git clone gits@xcdl190260:aisw/unilog; cd unilog; ${script_path}/cmake.sh --project unilog)

target:
	(cd ..; [ -d target_factory ] ||  git clone gits@xcdl190260:aisw/target_factory; cd target_factory; ${script_path}/cmake.sh --project target_factory)

xir:
	(cd ..; [ -d xir ] ||  git clone gits@xcdl190260:aisw/xir; cd xir; ${script_path}/cmake.sh --project xir --build-python)

vart:
	(cd ..; [ -d vart ] ||  git clone gits@xcdl190260:aisw/vart; cd vart; ${script_path}/cmake.sh --project vart --build-python --cmake-options='-DENABLE_DPU_RUNNER=ON' --cmake-options='-DENABLE_SIM_RUNNER=ON' --cmake-options='-DENABLE_CPU_RUNNER=ON')

vitis:
	(cd .; ${script_path}/cmake.sh --project Vitis-AI-Library --build-python --cmake-options="-DENABLE_OVERVIEW=ON")

=== tools/AKS/examples/CMakeLists.txt ===
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.12)
set(CMAKE_CXX_STANDARD 17)

project(examples VERSION 1.4.0)

# Set source files of examples (non-video)
set (EXAMPLES_IMAGE
  tf_resnet_v1_50.cpp
  cf_resnet50.cpp
  cf_densebox_320_320.cpp
)

# Set source files of examples (video)
set (EXAMPLES_VIDEO
  ""
)

# Find Packages
find_package(xir REQUIRED)
find_package(unilog REQUIRED)
find_package(vart REQUIRED)

if (NOT "${AKS_INSTALL_PREFIX}" STREQUAL "")
  message(STATUS "AKS Install Prefix: ${AKS_INSTALL_PREFIX}")
  find_package(aks REQUIRED
    PATHS ${AKS_INSTALL_PREFIX}
    NO_DEFAULT_PATH
  )
else()
  find_package(aks REQUIRED)
endif()
message(STATUS "AKS Includes: ${aks_INCLUDE_DIRS}")
message(STATUS "AKS libraries: ${aks_LIBRARIES}")

execute_process(COMMAND uname -m OUTPUT_VARIABLE arch)
find_package(Threads REQUIRED)
if(${arch} MATCHES ".*x86.*" AND (NOT DEFINED ENV{OECORE_TARGET_ARCH}))
  find_package(Boost 1.65.1 EXACT REQUIRED COMPONENTS system filesystem)
else()
  find_package(Boost 1.65.1 REQUIRED COMPONENTS system filesystem)
endif()
find_package(OpenCV REQUIRED COMPONENTS core imgproc video videoio imgcodecs)

# Set output directories for executables
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)

# Compile Sources
foreach( sourcefile ${EXAMPLES_IMAGE} )
  # Generate executable name
  string( REPLACE ".cpp" ".exe" exename ${sourcefile} )

  # Set target
  add_executable( ${exename} ${sourcefile} )

  # Set include dirs
  target_include_directories (${exename}
    PRIVATE ${aks_INCLUDE_DIRS}
    PRIVATE ${Boost_INCLUDE_DIRS}
    PRIVATE ${OpenCV_INCLUDE_DIRS}
  )

  # Set libraries to be linked
  target_link_libraries (${exename}
    PRIVATE ${aks_LIBRARIES}
    PRIVATE ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY}
    PRIVATE ${CMAKE_DL_LIBS}
    PRIVATE ${CMAKE_THREAD_LIBS_INIT}
    PRIVATE vart-runner
    PRIVATE xir unilog
    PRIVATE opencv_core opencv_imgproc opencv_imgcodecs
  )
  # set (CMAKE_DEBUG_TARGET_PROPERTIES INCLUDE_DIRECTORIES)
endforeach()

# Compile Sources
foreach( sourcefile ${EXAMPLES_VIDEO} )
  # Generate executable name
  string( REPLACE ".cpp" ".exe" exename ${sourcefile} )

  # Set target
  add_executable( ${exename} ${sourcefile} )

  # Set include dirs
  target_include_directories (${exename}
    PRIVATE ${aks_INCLUDE_DIRS}
    PRIVATE ${OpenCV_INCLUDE_DIRS}
  )

  # Set libraries to be linked
  target_link_libraries (${exename}
    PRIVATE ${aks_LIBRARIES}
    PRIVATE ${CMAKE_DL_LIBS}
    PRIVATE ${CMAKE_THREAD_LIBS_INIT}
    PRIVATE opencv_core opencv_imgproc opencv_video opencv_videoio
    PRIVATE vart-runner
    PRIVATE xir unilog
  )
  # set (CMAKE_DEBUG_TARGET_PROPERTIES INCLUDE_DIRECTORIES)
endforeach()

=== tools/RNN/rnn_quantizer/CMakeLists.txt ===
IF (APPLE)
    cmake_minimum_required(VERSION 3.4)
ELSE()
    cmake_minimum_required(VERSION 2.8)
ENDIF()

project(nndct_release)

IF (NOT APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp -O2")
ENDIF()

IF (APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -O2")
    add_definitions(-DAPPLE)
ENDIF()

FIND_PACKAGE(CUDA 6.5)
MESSAGE(STATUS "cuda found ${CUDA_FOUND}")

option(WITH_GPU "compile nndct with cuda." ${CUDA_FOUND})
option(WITH_OMP "compile nndct with openmp." ON)

if(WITH_GPU)
	add_definitions(-DNNDCT_ENABLE_GPU)
endif()

if(NOT WITH_OMP)
	add_definitions(-DNNDCT_DISABLE_OMP)
endif()

# need to be at least 30 or __shfl_down in reduce wont compile
#set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_30,code=sm_30")
set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_35,code=sm_35")

set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_50,code=sm_50")
set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_52,code=sm_52")

IF (CUDA_VERSION GREATER 7.6)
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_60,code=sm_60")
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_61,code=sm_61")
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_62,code=sm_62")
ENDIF()

IF (CUDA_VERSION GREATER 8.9)
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_70,code=sm_70")
ENDIF()

IF (CUDA_VERSION GREATER 9.9)
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_75,code=sm_75")
ENDIF()

IF (CUDA_VERSION GREATER 10.9)
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_80,code=sm_80")
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_86,code=sm_86")
ENDIF()

if (NOT APPLE)
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -O2 --std=c++14")
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -Xcompiler -fopenmp")
ENDIF()

IF (APPLE)
    EXEC_PROGRAM(uname ARGS -v  OUTPUT_VARIABLE DARWIN_VERSION)
    STRING(REGEX MATCH "[0-9]+" DARWIN_VERSION ${DARWIN_VERSION})
    MESSAGE(STATUS "DARWIN_VERSION=${DARWIN_VERSION}")

    #for el capitain have to use rpath

    IF (DARWIN_VERSION LESS 15)
        set(CMAKE_SKIP_RPATH TRUE)
    ENDIF ()

ELSE()
    #always skip for linux
    set(CMAKE_SKIP_RPATH TRUE)
ENDIF()


IF (WITH_GPU)

    MESSAGE(STATUS "Building shared library with GPU support")
    
    FILE(GLOB_RECURSE CC_LIST ./csrc/*.cc)
    FILE(GLOB_RECURSE CU_LIST ./csrc/*.cu)
    CUDA_ADD_LIBRARY(nndct SHARED ${CC_LIST} ${CU_LIST})

    TARGET_LINK_LIBRARIES(nndct ${CUDA_curand_LIBRARY})

    INSTALL(TARGETS nndct
            RUNTIME DESTINATION "bin"
            LIBRARY DESTINATION "lib"
            ARCHIVE DESTINATION "lib")

ELSE()
    MESSAGE(STATUS "Building shared library with no GPU support")

ENDIF()

=== tools/RNN/rnn_quantizer/requirements.txt ===
sklearn
scipy==1.3.1
numpy==1.17.2
tqdm
ninja
six

=== tools/Vitis-AI-Library/3Dsegmentation/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#

vai_add_library(
  SRCS include/vitis/ai/3Dsegmentation.hpp src/3Dsegmentation.cpp
       src/3Dsegmentation_imp.hpp src/3Dsegmentation_imp.cpp src/post.cpp src/post.hpp  src/post_util.hpp
  PUBLIC_REQUIRE ${PROJECT_NAME}::xnnpp ${PROJECT_NAME}::dpu_task)


target_include_directories(${COMPONENT_NAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src)
target_include_directories(${COMPONENT_NAME} PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
vai_add_test(test_3Dsegmentation)
vai_add_test(test_3Dsegmentation_batch)
vai_add_test(test_3Dsegmentation_accuracy)

=== tools/Vitis-AI-Library/RGBDsegmentation/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#
vai_add_library(
  SRCS include/vitis/ai/RGBDsegmentation.hpp src/RGBDsegmentation.cpp
       src/RGBDsegmentation_imp.cpp src/utils.cpp
  PUBLIC_REQUIRE ${PROJECT_NAME}::xnnpp ${PROJECT_NAME}::dpu_task)

vai_add_test(test_RGBDsegmentation)
vai_add_test(test_RGBDsegmentation_accuracy)

=== tools/Vitis-AI-Library/bcc/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

vai_add_library(
  SRCS include/vitis/ai/bcc.hpp src/bcc.cpp src/bcc_imp.cpp
       src/bcc_imp.hpp #
  PUBLIC_REQUIRE ${PROJECT_NAME}::dpu_task)

vai_add_test(test_bcc)
vai_add_test(test_bcc_batch)
vai_add_test(test_bcc_accuracy REQUIRE PkgConfig::JSONC)

=== tools/Vitis-AI-Library/benchmark/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#

vai_add_library(
  SRCS include/vitis/ai/benchmark.hpp
       include/vitis/ai/demo.hpp
       include/vitis/ai/demo2.hpp
       include/vitis/ai/demo3.hpp
       include/vitis/ai/dpdrm.hpp
       include/vitis/ai/image_list.hpp
       include/vitis/ai/stat_samples.hpp
       include/vitis/ai/demo_accuracy.hpp
       # src/accuracy_facedetection.hpp src/main.cpp src/stat_samples.cpp
)

=== tools/Vitis-AI-Library/c2d2_lite/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#

vai_add_library(
  SRCS include/vitis/ai/c2d2_lite.hpp src/c2d2_lite.cpp src/c2d2_lite_imp.hpp
       src/c2d2_lite_imp.cpp 
  PUBLIC_REQUIRE ${PROJECT_NAME}::xnnpp ${PROJECT_NAME}::dpu_task)

vai_add_test(test_c2d2_lite)

=== tools/Vitis-AI-Library/carplaterecog/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#

vai_add_library(
  SRCS include/vitis/ai/carplaterecog.hpp src/carplaterecog.cpp
       src/carplaterecog_imp.hpp src/carplaterecog_imp.cpp
  PUBLIC_REQUIRE ${PROJECT_NAME}::platerecog ${PROJECT_NAME}::ssd
                 ${OpenCV_LIBS} glog::glog)

vai_add_test(test_carplaterecog)
vai_add_test(test_carplaterecog_batch)

=== tools/Vitis-AI-Library/centerpoint/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#

if(CPACK_DEBIAN_PACKAGE_ARCHITECTURE STREQUAL "arm64")
  add_compile_options(-Wno-error=attributes -Wno-strict-aliasing)
endif()


vai_add_library(
  SRCS ${LIST_PBSRC_CC}
       src/centerpoint.cpp
       src/centerpoint_imp.hpp
       src/centerpoint_imp.cpp
       src/middle_process.hpp
       src/middle_process.cpp
       src/preprocess.cpp
       src/preprocess.hpp
  PUBLIC_REQUIRE ${PROJECT_NAME}::xnnpp ${PROJECT_NAME}::dpu_task xir::xir)

target_include_directories(${COMPONENT_NAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src)
target_include_directories(${COMPONENT_NAME} PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
vai_add_test(test_centerpoint)
vai_add_test(test_centerpoint_batch)

=== debian/changelog ===
vitis-ai (2.0-0ubuntu1) jammy; urgency=medium

  [ Łukasz 'sil2100' Zemczak ]
  * New upstream release (LP: #1959382).
    - Exclude multiple invalid files from the upstream tarball that would
      make this package incompatible with universe.
  * debian/patches: drop unneeded patches, refresh still relevant ones.
  * Add debian/patches/fix-python-install.patch to allow installing the python
    modules to the debian/tmp directory for package builds.
  * Add debian/patches/fix-ftbfs-includes-and-namespaces.patch to fix
    compliation errors due to missing includes or namespaces.
  * Drop vitis-ai-dnndk as it is no longer present since 1.4+.
  * Install all the newly added Vitis-AI libraries.
  * Tweak debian/copyright to be more accurate.
  * Build python libraries and utilities for Vitis-AI-Library.

  [ Alfonso Sanchez-Beato ]
  * Move to the newer name for xrt package (xrt-embedded -> xrt)
  * Make sure all VART libraries are in vitis-ai-runtime package
  * Replace fix for -Werror=nonnull with something maybe safer

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Fri, 28 Jan 2022 12:01:04 +0100

vitis-ai (1.3.2-0ubuntu9) jammy; urgency=medium

  * Build python libraries (LP: #1958484)
  * Build with -std=gnu++17 to fix build failure

 -- Ethan Hsieh <ethan.hsieh@canonical.com>  Fri, 07 Jan 2022 03:46:51 +0000

vitis-ai (1.3.2-0ubuntu8) jammy; urgency=medium

  * d/rules: Build with -Wno-error=deprecated-declarations to fix build
    failure against OpenSSL 3.0

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 07 Dec 2021 15:54:04 +0100

=== debian/control ===
Source: vitis-ai
Section: libdevel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libboost-filesystem-dev,
               libeigen3-dev,
               libgtest-dev,
               libgoogle-glog-dev,
               libjson-c-dev,
               libopencv-dev,
               libprotobuf-dev,
               libssl-dev,
               lsb-release,
               pkg-config,
               protobuf-compiler,
               xrt,
               uuid-dev,
               python3-dev,
               pybind11-dev,
Standards-Version: 4.5.0

Package: vitis-ai-runtime
Architecture: arm64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Vitis AI runtime
 Vitis AI Run time enables applications to use the unified high-level
 runtime API for both cloud and edge. Therefore, making cloud-to-edge
 deployments seamless and efficient.
 The Vitis AI Runtime API features are:
 * Asynchronous submission of jobs to the accelerator
 * Asynchronous collection of jobs from the accelerator
 * C++ and Python implementations
 * Support for multi-threading and multi-process execution
 .
 This package contains the Vitis AI runtime libraries, headers, and tools.

Package: vitis-ai-library
Architecture: arm64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Vitis AI library
 The Vitis AI Library is a set of high-level libraries and APIs built for
 efficient AI inference with Deep-Learning Processor Unit (DPU). It is
 built based on the Vitis AI Runtime with Unified APIs, and it fully
 supports XRT 2020.2.
 .
 The Vitis AI Library provides an easy-to-use and unified interface by
 encapsulating many efficient and high-quality neural networks. This
 simplifies the use of deep-learning neural networks, even for users
 without knowledge of deep-learning or FPGAs. The Vitis AI Library allows
 users to focus more on the development of their applications, rather
 than the underlying hardware.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CXXFLAGS_MAINT_APPEND := -Wno-error=range-loop-construct -Wno-error=deprecated-declarations

%:
	dh $@ --with autoreconf

override_dh_auto_build:
	cd tools/Vitis-AI-Runtime/VART/unilog; \
	    ./cmake.sh --type=release \
	        --cmake-options -DIS_EDGE=TRUE \
	        --build-dir=$(CURDIR)/debian/build-unilog/ \
	        --install-prefix=$(CURDIR)/debian/tmp/usr/ \
	        --cmake-options='-DBUILD_TEST=OFF'
	cd tools/Vitis-AI-Runtime/VART/xir; \
	    ./cmake.sh --type=release \
	        --cmake-options -DIS_EDGE=TRUE \
	        --build-dir=$(CURDIR)/debian/build-xir/ \
	        --install-prefix=$(CURDIR)/debian/tmp/usr/ \
	        --cmake-options='-DBUILD_TEST=OFF' \
	        --build-python
	cd tools/Vitis-AI-Runtime/VART/target_factory; \
	    ./cmake.sh --type=release \
	        --cmake-options -DIS_EDGE=TRUE \
	        --build-dir=$(CURDIR)/debian/build-target_factory/ \
                --install-prefix=$(CURDIR)/debian/tmp/usr/ \
	        --cmake-options='-DBUILD_TEST=OFF'
	cd tools/Vitis-AI-Runtime/VART/vart; \
	    ./cmake.sh --type=release \
	        --cmake-options -DIS_EDGE=TRUE \
	        --build-dir=$(CURDIR)/debian/build-vart/ \
                --install-prefix=$(CURDIR)/debian/tmp/usr/ \
	        --cmake-options='-DBUILD_TEST=OFF -DENABLE_DPU_RUNNER=ON -DENABLE_CPU_RUNNER=OFF -DENABLE_SIM_RUNNER=OFF' \
	        --build-python
	cd tools/Vitis-AI-Library; \
	    ./cmake.sh --type=release \
	        --cmake-options '-DBUILD_TEST=OFF -DIS_EDGE=TRUE' \
	        --build-dir=$(CURDIR)/debian/build-library/ \
	        --install-prefix=$(CURDIR)/debian/tmp/usr/ \
	        --build-python

override_dh_auto_clean:
	rm -rf $(CURDIR)/debian/build-*

# dh_prep removes debian/tmp, and we do not want that
override_dh_prep:

=== debian/watch ===
version=4
opts="filenamemangle=s%.*\/v(\d.*)\.tar\.gz%vitis-ai-$1.tar.gz%" \
    https://github.com/Xilinx/Vitis-AI/releases \
    .*\/v(\d.*)\.tar\.gz debian uupdate
